searchNodes=[{"doc":"Minimal HTTP ClickHouse client.","ref":"Ch.html","title":"Ch","type":"module"},{"doc":"Returns a supervisor child specification for a DBConnection pool.","ref":"Ch.html#child_spec/1","title":"Ch.child_spec/1","type":"function"},{"doc":"Runs a query and returns the result as {:ok, %Ch.Result{}} or {:error, Exception.t()} if there was a database error. Options :timeout - Query request timeout :settings - Keyword list of settings :database - Database :username - Username :password - User password","ref":"Ch.html#query/4","title":"Ch.query/4","type":"function"},{"doc":"Runs a query and returns the result or raises Ch.Error if there was an error. See query/4 .","ref":"Ch.html#query!/4","title":"Ch.query!/4","type":"function"},{"doc":"Start the connection process and connect to ClickHouse. Options :hostname - server hostname, defaults to &quot;localhost&quot; :port - HTTP port, defualts to 8123 :scheme - HTTP scheme, defaults to &quot;http&quot; :database - Database, defaults to &quot;default&quot; :username - Username :password - User password :settings - Keyword list of ClickHouse settings :timeout - HTTP receive timeout in milliseconds :transport_opts - options to be given to the transport being used. See Mint.HTTP1.connect/4 for more info","ref":"Ch.html#start_link/1","title":"Ch.start_link/1","type":"function"},{"doc":"Query struct wrapping the SQL statement.","ref":"Ch.Query.html","title":"Ch.Query","type":"module"},{"doc":"","ref":"Ch.Query.html#t:t/0","title":"Ch.Query.t/0","type":"type"},{"doc":"Result struct returned from any successful query. Its fields are: command - An atom of the query command, for example: :select , :insert ; rows - The result set. One of: a list of lists, each inner list corresponding to a row, each element in the inner list corresponds to a column; raw iodata when the response is not automatically decoded, e.g. x-clickhouse-format: CSV num_rows - The number of fetched or affected rows; headers - The HTTP response headers","ref":"Ch.Result.html","title":"Ch.Result","type":"module"},{"doc":"","ref":"Ch.Result.html#t:t/0","title":"Ch.Result.t/0","type":"type"},{"doc":"Helpers for working with ClickHouse RowBinary format.","ref":"Ch.RowBinary.html","title":"Ch.RowBinary","type":"module"},{"doc":"Decodes RowBinaryWithNamesAndTypes into rows. Example: iex&gt; decode_rows ( &lt;&lt; 1 , 3 , &quot;1+1&quot; :: bytes , 5 , &quot;UInt8&quot; :: bytes , 2 &gt;&gt; ) [ [ 2 ] ]","ref":"Ch.RowBinary.html#decode_rows/1","title":"Ch.RowBinary.decode_rows/1","type":"function"},{"doc":"Decodes RowBinary into rows. Example: iex&gt; decode_rows ( &lt;&lt; 1 &gt;&gt; , [ &quot;UInt8&quot; ] ) [ [ 1 ] ]","ref":"Ch.RowBinary.html#decode_rows/2","title":"Ch.RowBinary.decode_rows/2","type":"function"},{"doc":"Encodes a single row to RowBinary as iodata. Examples: iex&gt; encode_row ( [ ] , [ ] ) [ ] iex&gt; encode_row ( [ 1 ] , [ &quot;UInt8&quot; ] ) [ 1 ] iex&gt; encode_row ( [ 3 , &quot;hello&quot; ] , [ &quot;UInt8&quot; , &quot;String&quot; ] ) [ 3 , [ 5 | &quot;hello&quot; ] ]","ref":"Ch.RowBinary.html#encode_row/2","title":"Ch.RowBinary.encode_row/2","type":"function"},{"doc":"Encodes multiple rows to RowBinary as iodata. Examples: iex&gt; encode_rows ( [ ] , [ ] ) [ ] iex&gt; encode_rows ( [ [ 1 ] ] , [ &quot;UInt8&quot; ] ) [ 1 ] iex&gt; encode_rows ( [ [ 3 , &quot;hello&quot; ] , [ 4 , &quot;hi&quot; ] ] , [ &quot;UInt8&quot; , &quot;String&quot; ] ) [ 3 , [ 5 | &quot;hello&quot; ] , 4 , [ 2 | &quot;hi&quot; ] ]","ref":"Ch.RowBinary.html#encode_rows/2","title":"Ch.RowBinary.encode_rows/2","type":"function"},{"doc":"Helpers to turn ClickHouse types into Elixir terms for easier processing.","ref":"Ch.Types.html","title":"Ch.Types","type":"module"},{"doc":"Helper for Array(T) ClickHouse type: iex&gt; array ( u64 ( ) ) { :array , :u64 } iex&gt; to_string ( encode ( array ( u64 ( ) ) ) ) &quot;Array(UInt64)&quot; iex&gt; decode ( &quot;Array(UInt64)&quot; ) array ( u64 ( ) )","ref":"Ch.Types.html#array/1","title":"Ch.Types.array/1","type":"function"},{"doc":"Helper for Bool ClickHouse type: iex&gt; boolean ( ) :boolean iex&gt; encode ( boolean ( ) ) &quot;Bool&quot; iex&gt; decode ( &quot;Bool&quot; ) boolean ( )","ref":"Ch.Types.html#boolean/0","title":"Ch.Types.boolean/0","type":"function"},{"doc":"Helper for Date32 ClickHouse type: iex&gt; date32 ( ) :date32 iex&gt; encode ( date32 ( ) ) &quot;Date32&quot; iex&gt; decode ( &quot;Date32&quot; ) date32 ( )","ref":"Ch.Types.html#date32/0","title":"Ch.Types.date32/0","type":"function"},{"doc":"Helper for Date ClickHouse type: iex&gt; date ( ) :date iex&gt; encode ( date ( ) ) &quot;Date&quot; iex&gt; decode ( &quot;Date&quot; ) date ( )","ref":"Ch.Types.html#date/0","title":"Ch.Types.date/0","type":"function"},{"doc":"Helper for DateTime64(precision) ClickHouse type: iex&gt; datetime64 ( 3 ) { :datetime64 , 3 } iex&gt; to_string ( encode ( datetime64 ( 3 ) ) ) &quot;DateTime64(3)&quot; iex&gt; decode ( &quot;DateTime64(3)&quot; ) datetime64 ( 3 )","ref":"Ch.Types.html#datetime64/1","title":"Ch.Types.datetime64/1","type":"function"},{"doc":"Helper for DateTime64(precision, timezone) ClickHouse type: iex&gt; datetime64 ( 3 , &quot;UTC&quot; ) { :datetime64 , 3 , &quot;UTC&quot; } iex&gt; to_string ( encode ( datetime64 ( 3 , &quot;UTC&quot; ) ) ) &quot;DateTime64(3, &#39;UTC&#39;)&quot; iex&gt; decode ( &quot;DateTime64(3, &#39;UTC&#39;)&quot; ) datetime64 ( 3 , &quot;UTC&quot; )","ref":"Ch.Types.html#datetime64/2","title":"Ch.Types.datetime64/2","type":"function"},{"doc":"Helper for DateTime ClickHouse type: iex&gt; datetime ( ) :datetime iex&gt; to_string ( encode ( datetime ( ) ) ) &quot;DateTime&quot; iex&gt; decode ( &quot;DateTime&quot; ) datetime ( )","ref":"Ch.Types.html#datetime/0","title":"Ch.Types.datetime/0","type":"function"},{"doc":"Helper for DateTime(timezone) ClickHouse type: iex&gt; datetime ( &quot;Europe/Vienna&quot; ) { :datetime , &quot;Europe/Vienna&quot; } iex&gt; to_string ( encode ( datetime ( &quot;UTC&quot; ) ) ) &quot;DateTime(&#39;UTC&#39;)&quot; iex&gt; decode ( &quot;DateTime(&#39;UTC&#39;)&quot; ) datetime ( &quot;UTC&quot; )","ref":"Ch.Types.html#datetime/1","title":"Ch.Types.datetime/1","type":"function"},{"doc":"Helper for Decimal32(S) ClickHouse type: iex&gt; decimal32 ( 4 ) { :decimal32 , 4 } iex&gt; to_string ( encode ( decimal32 ( 4 ) ) ) &quot;Decimal32(4)&quot; iex&gt; decode ( &quot;Decimal32(4)&quot; ) { :decimal32 , 4 }","ref":"Ch.Types.html#decimal32/1","title":"Ch.Types.decimal32/1","type":"function"},{"doc":"Helper for Decimal64(S) ClickHouse type: iex&gt; decimal64 ( 4 ) { :decimal64 , 4 } iex&gt; to_string ( encode ( decimal64 ( 4 ) ) ) &quot;Decimal64(4)&quot; iex&gt; decode ( &quot;Decimal64(4)&quot; ) { :decimal64 , 4 }","ref":"Ch.Types.html#decimal64/1","title":"Ch.Types.decimal64/1","type":"function"},{"doc":"Helper for Decimal128(S) ClickHouse type: iex&gt; decimal128 ( 4 ) { :decimal128 , 4 } iex&gt; to_string ( encode ( decimal128 ( 4 ) ) ) &quot;Decimal128(4)&quot; iex&gt; decode ( &quot;Decimal128(4)&quot; ) { :decimal128 , 4 }","ref":"Ch.Types.html#decimal128/1","title":"Ch.Types.decimal128/1","type":"function"},{"doc":"Helper for Decimal256(S) ClickHouse type: iex&gt; decimal256 ( 4 ) { :decimal256 , 4 } iex&gt; to_string ( encode ( decimal256 ( 4 ) ) ) &quot;Decimal256(4)&quot; iex&gt; decode ( &quot;Decimal256(4)&quot; ) { :decimal256 , 4 }","ref":"Ch.Types.html#decimal256/1","title":"Ch.Types.decimal256/1","type":"function"},{"doc":"Helper for Decimal(P, S) ClickHouse type: iex&gt; decimal ( 18 , 4 ) { :decimal , 18 , 4 } iex&gt; to_string ( encode ( decimal ( 18 , 4 ) ) ) &quot;Decimal(18, 4)&quot; iex&gt; decode ( &quot;Decimal(18, 4)&quot; ) decimal ( 18 , 4 )","ref":"Ch.Types.html#decimal/2","title":"Ch.Types.decimal/2","type":"function"},{"doc":"Decodes a ClickHouse type into an intermediary Elixir term. iex&gt; decode ( &quot;String&quot; ) :string iex&gt; decode ( &quot;Array(String)&quot; ) { :array , :string } iex&gt; decode ( &quot;Enum8(&#39;hello&#39; = 1, &#39;world&#39; = 2)&quot; ) { :enum8 , [ { &quot;world&quot; , 2 } , { &quot;hello&quot; , 1 } ] } iex&gt; decode ( &quot;Nullable(Decimal(18, 4))&quot; ) { :nullable , { :decimal , 18 , 4 } }","ref":"Ch.Types.html#decode/1","title":"Ch.Types.decode/1","type":"function"},{"doc":"Encodes a type from Elixir atom / tuple to proper ClickHouse name. iex&gt; encode ( :string ) &quot;String&quot; iex&gt; IO . iodata_to_binary ( encode ( { :nullable , :i8 } ) ) &quot;Nullable(Int8)&quot;","ref":"Ch.Types.html#encode/1","title":"Ch.Types.encode/1","type":"function"},{"doc":"Helper for Enum8 ClickHouse type: iex&gt; enum8 ( [ { &quot;hello&quot; , 1 } , { &quot;world&quot; , 2 } ] ) { :enum8 , [ { &quot;hello&quot; , 1 } , { &quot;world&quot; , 2 } ] } iex&gt; to_string ( encode ( enum8 ( [ { &quot;hello&quot; , 1 } , { &quot;world&quot; , 2 } ] ) ) ) &quot;Enum8(&#39;hello&#39; = 1, &#39;world&#39; = 2)&quot; # note that the order is reversed iex&gt; decode ( &quot;Enum8(&#39;hello&#39; = 1, &#39;world&#39; = 2)&quot; ) enum8 ( [ { &quot;world&quot; , 2 } , { &quot;hello&quot; , 1 } ] )","ref":"Ch.Types.html#enum8/1","title":"Ch.Types.enum8/1","type":"function"},{"doc":"Helper for Enum16 ClickHouse type: iex&gt; enum16 ( [ { &quot;hello&quot; , 1 } , { &quot;world&quot; , 2 } ] ) { :enum16 , [ { &quot;hello&quot; , 1 } , { &quot;world&quot; , 2 } ] } iex&gt; to_string ( encode ( enum16 ( [ { &quot;hello&quot; , 1 } , { &quot;world&quot; , 2 } ] ) ) ) &quot;Enum16(&#39;hello&#39; = 1, &#39;world&#39; = 2)&quot; # note that the order is reversed iex&gt; decode ( &quot;Enum16(&#39;hello&#39; = 1, &#39;world&#39; = 2)&quot; ) enum16 ( [ { &quot;world&quot; , 2 } , { &quot;hello&quot; , 1 } ] )","ref":"Ch.Types.html#enum16/1","title":"Ch.Types.enum16/1","type":"function"},{"doc":"Helper for Float32 ClickHouse type: iex&gt; f32 ( ) :f32 iex&gt; encode ( f32 ( ) ) &quot;Float32&quot; iex&gt; decode ( &quot;Float32&quot; ) f32 ( )","ref":"Ch.Types.html#f32/0","title":"Ch.Types.f32/0","type":"function"},{"doc":"Helper for Float64 ClickHouse type: iex&gt; f64 ( ) :f64 iex&gt; encode ( f64 ( ) ) &quot;Float64&quot; iex&gt; decode ( &quot;Float64&quot; ) f64 ( )","ref":"Ch.Types.html#f64/0","title":"Ch.Types.f64/0","type":"function"},{"doc":"Helper for FixedString(n) ClickHouse type: iex&gt; fixed_string ( 3 ) { :fixed_string , 3 } iex&gt; to_string ( encode ( fixed_string ( 16 ) ) ) &quot;FixedString(16)&quot; iex&gt; decode ( &quot;FixedString(16)&quot; ) fixed_string ( 16 )","ref":"Ch.Types.html#fixed_string/1","title":"Ch.Types.fixed_string/1","type":"function"},{"doc":"Helper for Int8 ClickHouse type: iex&gt; i8 ( ) :i8 iex&gt; encode ( i8 ( ) ) &quot;Int8&quot; iex&gt; decode ( &quot;Int8&quot; ) i8 ( )","ref":"Ch.Types.html#i8/0","title":"Ch.Types.i8/0","type":"function"},{"doc":"Helper for Int16 ClickHouse type: iex&gt; i16 ( ) :i16 iex&gt; encode ( i16 ( ) ) &quot;Int16&quot; iex&gt; decode ( &quot;Int16&quot; ) i16 ( )","ref":"Ch.Types.html#i16/0","title":"Ch.Types.i16/0","type":"function"},{"doc":"Helper for Int32 ClickHouse type: iex&gt; i32 ( ) :i32 iex&gt; encode ( i32 ( ) ) &quot;Int32&quot; iex&gt; decode ( &quot;Int32&quot; ) i32 ( )","ref":"Ch.Types.html#i32/0","title":"Ch.Types.i32/0","type":"function"},{"doc":"Helper for Int64 ClickHouse type: iex&gt; i64 ( ) :i64 iex&gt; encode ( i64 ( ) ) &quot;Int64&quot; iex&gt; decode ( &quot;Int64&quot; ) i64 ( )","ref":"Ch.Types.html#i64/0","title":"Ch.Types.i64/0","type":"function"},{"doc":"Helper for Int128 ClickHouse type: iex&gt; i128 ( ) :i128 iex&gt; encode ( i128 ( ) ) &quot;Int128&quot; iex&gt; decode ( &quot;Int128&quot; ) i128 ( )","ref":"Ch.Types.html#i128/0","title":"Ch.Types.i128/0","type":"function"},{"doc":"Helper for Int256 ClickHouse type: iex&gt; i256 ( ) :i256 iex&gt; encode ( i256 ( ) ) &quot;Int256&quot; iex&gt; decode ( &quot;Int256&quot; ) i256 ( )","ref":"Ch.Types.html#i256/0","title":"Ch.Types.i256/0","type":"function"},{"doc":"Helper for IPv4 ClickHouse type: iex&gt; ipv4 ( ) :ipv4 iex&gt; encode ( ipv4 ( ) ) &quot;IPv4&quot; iex&gt; decode ( &quot;IPv4&quot; ) ipv4 ( )","ref":"Ch.Types.html#ipv4/0","title":"Ch.Types.ipv4/0","type":"function"},{"doc":"Helper for IPv6 ClickHouse type: iex&gt; ipv6 ( ) :ipv6 iex&gt; encode ( ipv6 ( ) ) &quot;IPv6&quot; iex&gt; decode ( &quot;IPv6&quot; ) ipv6 ( )","ref":"Ch.Types.html#ipv6/0","title":"Ch.Types.ipv6/0","type":"function"},{"doc":"Helper for LowCardinality(T) ClickHouse type: iex&gt; low_cardinality ( string ( ) ) { :low_cardinality , :string } iex&gt; to_string ( encode ( low_cardinality ( string ( ) ) ) ) &quot;LowCardinality(String)&quot; iex&gt; decode ( &quot;LowCardinality(String)&quot; ) low_cardinality ( string ( ) )","ref":"Ch.Types.html#low_cardinality/1","title":"Ch.Types.low_cardinality/1","type":"function"},{"doc":"Helper for Map(K, V) ClickHouse type: iex&gt; map ( string ( ) , array ( string ( ) ) ) { :map , :string , { :array , :string } } iex&gt; to_string ( encode ( map ( string ( ) , array ( string ( ) ) ) ) ) &quot;Map(String, Array(String))&quot; iex&gt; decode ( &quot;Map(String, Array(String))&quot; ) map ( string ( ) , array ( string ( ) ) )","ref":"Ch.Types.html#map/2","title":"Ch.Types.map/2","type":"function"},{"doc":"Helper for MultiPolygon ClickHouse type: iex&gt; multipolygon ( ) :multipolygon iex&gt; encode ( multipolygon ( ) ) &quot;MultiPolygon&quot; iex&gt; decode ( &quot;MultiPolygon&quot; ) multipolygon ( )","ref":"Ch.Types.html#multipolygon/0","title":"Ch.Types.multipolygon/0","type":"function"},{"doc":"Helper for Nothing ClickHouse type: iex&gt; nothing ( ) :nothing iex&gt; encode ( nothing ( ) ) &quot;Nothing&quot; iex&gt; decode ( &quot;Nothing&quot; ) nothing ( )","ref":"Ch.Types.html#nothing/0","title":"Ch.Types.nothing/0","type":"function"},{"doc":"Helper for Nullable(T) ClickHouse type: iex&gt; nullable ( array ( boolean ( ) ) ) { :nullable , { :array , :boolean } } iex&gt; to_string ( encode ( nullable ( array ( boolean ( ) ) ) ) ) &quot;Nullable(Array(Bool))&quot; iex&gt; decode ( &quot;Nullable(Array(Bool))&quot; ) nullable ( array ( boolean ( ) ) )","ref":"Ch.Types.html#nullable/1","title":"Ch.Types.nullable/1","type":"function"},{"doc":"Helper for Point ClickHouse type: iex&gt; point ( ) :point iex&gt; encode ( point ( ) ) &quot;Point&quot; iex&gt; decode ( &quot;Point&quot; ) point ( )","ref":"Ch.Types.html#point/0","title":"Ch.Types.point/0","type":"function"},{"doc":"Helper for Polygon ClickHouse type: iex&gt; polygon ( ) :polygon iex&gt; encode ( polygon ( ) ) &quot;Polygon&quot; iex&gt; decode ( &quot;Polygon&quot; ) polygon ( )","ref":"Ch.Types.html#polygon/0","title":"Ch.Types.polygon/0","type":"function"},{"doc":"Helper for Ring ClickHouse type: iex&gt; ring ( ) :ring iex&gt; encode ( ring ( ) ) &quot;Ring&quot; iex&gt; decode ( &quot;Ring&quot; ) ring ( )","ref":"Ch.Types.html#ring/0","title":"Ch.Types.ring/0","type":"function"},{"doc":"Helper for SimpleAggregateFunction(name, type) ClickHouse type: iex&gt; simple_aggregate_function ( &quot;any&quot; , u8 ( ) ) { :simple_aggregate_function , &quot;any&quot; , :u8 } iex&gt; to_string ( encode ( simple_aggregate_function ( &quot;any&quot; , u8 ( ) ) ) ) &quot;SimpleAggregateFunction(any, UInt8)&quot; iex&gt; decode ( &quot;SimpleAggregateFunction(any, UInt8)&quot; ) simple_aggregate_function ( &quot;any&quot; , u8 ( ) )","ref":"Ch.Types.html#simple_aggregate_function/2","title":"Ch.Types.simple_aggregate_function/2","type":"function"},{"doc":"Helper for String ClickHouse type: iex&gt; string ( ) :string iex&gt; encode ( string ( ) ) &quot;String&quot; iex&gt; decode ( &quot;String&quot; ) string ( )","ref":"Ch.Types.html#string/0","title":"Ch.Types.string/0","type":"function"},{"doc":"Helper for Tuple(T1, T2, ...) ClickHouse type: iex&gt; tuple ( [ u64 ( ) , array ( string ( ) ) ] ) { :tuple , [ :u64 , { :array , :string } ] } iex&gt; to_string ( encode ( tuple ( [ u64 ( ) , array ( string ( ) ) ] ) ) ) &quot;Tuple(UInt64, Array(String))&quot; iex&gt; decode ( &quot;Tuple(UInt64, Array(String))&quot; ) tuple ( [ u64 ( ) , array ( string ( ) ) ] )","ref":"Ch.Types.html#tuple/1","title":"Ch.Types.tuple/1","type":"function"},{"doc":"Helper for UInt8 ClickHouse type: iex&gt; u8 ( ) :u8 iex&gt; encode ( u8 ( ) ) &quot;UInt8&quot; iex&gt; decode ( &quot;UInt8&quot; ) u8 ( )","ref":"Ch.Types.html#u8/0","title":"Ch.Types.u8/0","type":"function"},{"doc":"Helper for UInt16 ClickHouse type: iex&gt; u16 ( ) :u16 iex&gt; encode ( u16 ( ) ) &quot;UInt16&quot; iex&gt; decode ( &quot;UInt16&quot; ) u16 ( )","ref":"Ch.Types.html#u16/0","title":"Ch.Types.u16/0","type":"function"},{"doc":"Helper for UInt32 ClickHouse type: iex&gt; u32 ( ) :u32 iex&gt; encode ( u32 ( ) ) &quot;UInt32&quot; iex&gt; decode ( &quot;UInt32&quot; ) u32 ( )","ref":"Ch.Types.html#u32/0","title":"Ch.Types.u32/0","type":"function"},{"doc":"Helper for UInt64 ClickHouse type: iex&gt; u64 ( ) :u64 iex&gt; encode ( u64 ( ) ) &quot;UInt64&quot; iex&gt; decode ( &quot;UInt64&quot; ) u64 ( )","ref":"Ch.Types.html#u64/0","title":"Ch.Types.u64/0","type":"function"},{"doc":"Helper for UInt128 ClickHouse type: iex&gt; u128 ( ) :u128 iex&gt; encode ( u128 ( ) ) &quot;UInt128&quot; iex&gt; decode ( &quot;UInt128&quot; ) u128 ( )","ref":"Ch.Types.html#u128/0","title":"Ch.Types.u128/0","type":"function"},{"doc":"Helper for UInt256 ClickHouse type: iex&gt; u256 ( ) :u256 iex&gt; encode ( u256 ( ) ) &quot;UInt256&quot; iex&gt; decode ( &quot;UInt256&quot; ) u256 ( )","ref":"Ch.Types.html#u256/0","title":"Ch.Types.u256/0","type":"function"},{"doc":"Helper for UUID ClickHouse type: iex&gt; uuid ( ) :uuid iex&gt; encode ( uuid ( ) ) &quot;UUID&quot; iex&gt; decode ( &quot;UUID&quot; ) uuid ( )","ref":"Ch.Types.html#uuid/0","title":"Ch.Types.uuid/0","type":"function"},{"doc":"Error struct wrapping ClickHouse error responses.","ref":"Ch.Error.html","title":"Ch.Error","type":"exception"},{"doc":"","ref":"Ch.Error.html#exception/2","title":"Ch.Error.exception/2","type":"function"},{"doc":"","ref":"Ch.Error.html#t:t/0","title":"Ch.Error.t/0","type":"type"},{"doc":"Minimal HTTP ClickHouse client for Elixir. Used in Ecto ClickHouse adapter. Key features RowBinary Native query parameters Per query settings Minimal API","ref":"readme.html","title":"Ch","type":"extras"},{"doc":"defp deps do [ { :ch , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Ch - Installation","type":"extras"},{"doc":"Start DBConnection pool defaults = [ scheme : &quot;http&quot; , hostname : &quot;localhost&quot; , port : 8123 , database : &quot;default&quot; , settings : [ ] , pool_size : 1 , timeout : :timer . seconds ( 15 ) ] { :ok , pid } = Ch . start_link ( defaults ) Select rows { :ok , pid } = Ch . start_link ( ) { :ok , % Ch.Result { rows : [ [ 0 ] , [ 1 ] , [ 2 ] ] } } = Ch . query ( pid , &quot;SELECT * FROM system.numbers LIMIT 3&quot; ) { :ok , % Ch.Result { rows : [ [ 0 ] , [ 1 ] , [ 2 ] ] } } = Ch . query ( pid , &quot;SELECT * FROM system.numbers LIMIT {$0:UInt8}&quot; , [ 3 ] ) { :ok , % Ch.Result { rows : [ [ 0 ] , [ 1 ] , [ 2 ] ] } } = Ch . query ( pid , &quot;SELECT * FROM system.numbers LIMIT {limit:UInt8}&quot; , %{ &quot;limit&quot; =&gt; 3 } ) Note on datetime encoding in query parameters: %NaiveDateTime{} is encoded as text to make it assume the column's or ClickHouse server's timezone %DateTime{time_zone: &quot;Etc/UTC&quot;} is encoded as unix timestamp and is treated as UTC timestamp by ClickHouse encoding non UTC %DateTime{} raises ArgumentError Insert rows { :ok , pid } = Ch . start_link ( ) Ch . query! ( pid , &quot;CREATE TABLE IF NOT EXISTS ch_demo(id UInt64) ENGINE Null&quot; ) % Ch.Result { num_rows : 2 } = Ch . query! ( pid , &quot;INSERT INTO ch_demo(id) VALUES (0), (1)&quot; ) % Ch.Result { num_rows : 2 } = Ch . query! ( pid , &quot;INSERT INTO ch_demo(id) VALUES ({$0:UInt8}), ({$1:UInt32})&quot; , [ 0 , 1 ] ) % Ch.Result { num_rows : 2 } = Ch . query! ( pid , &quot;INSERT INTO ch_demo(id) VALUES ({a:UInt16}), ({b:UInt64})&quot; , %{ &quot;a&quot; =&gt; 0 , &quot;b&quot; =&gt; 1 } ) % Ch.Result { num_rows : 2 } = Ch . query! ( pid , &quot;INSERT INTO ch_demo(id) SELECT number FROM system.numbers LIMIT {limit:UInt8}&quot; , %{ &quot;limit&quot; =&gt; 2 } ) Insert rows as RowBinary (efficient) { :ok , pid } = Ch . start_link ( ) Ch . query! ( pid , &quot;CREATE TABLE IF NOT EXISTS ch_demo(id UInt64) ENGINE Null&quot; ) types = [ &quot;UInt64&quot; ] # or types = [ Ch.Types . u64 ( ) ] # or types = [ :u64 ] % Ch.Result { num_rows : 2 } = Ch . query! ( pid , &quot;INSERT INTO ch_demo(id) FORMAT RowBinary&quot; , [ [ 0 ] , [ 1 ] ] , types : types ) Note that RowBinary format encoding requires :types option to be provided. Insert rows in custom format { :ok , pid } = Ch . start_link ( ) Ch . query! ( pid , &quot;CREATE TABLE IF NOT EXISTS ch_demo(id UInt64) ENGINE Null&quot; ) csv = [ 0 , 1 ] |&gt; Enum . map ( &amp; to_string / 1 ) |&gt; Enum . intersperse ( ?\\n ) % Ch.Result { num_rows : 2 } = Ch . query! ( pid , &quot;INSERT INTO ch_demo(id) FORMAT CSV&quot; , { :raw , csv } ) Insert rows as chunked RowBinary stream { :ok , pid } = Ch . start_link ( ) Ch . query! ( pid , &quot;CREATE TABLE IF NOT EXISTS ch_demo(id UInt64) ENGINE Null&quot; ) stream = Stream . repeatedly ( fn -&gt; [ :rand . uniform ( 100 ) ] end ) chunked = Stream . chunk_every ( stream , 100 ) encoded = Stream . map ( chunked , fn chunk -&gt; Ch.RowBinary . encode_rows ( chunk , _types = [ &quot;UInt64&quot; ] ) end ) ten_encoded_chunks = Stream . take ( encoded , 10 ) % Ch.Result { num_rows : 1000 } = Ch . query ( pid , &quot;INSERT INTO ch_demo(id) FORMAT RowBinary&quot; , { :raw , ten_encoded_chunks } ) This query makes a transfer-encoding: chunked HTTP request while unfolding the stream resulting in lower memory usage. Query with custom settings { :ok , pid } = Ch . start_link ( ) settings = [ async_insert : 1 ] % Ch.Result { rows : [ [ &quot;async_insert&quot; , &quot;Bool&quot; , &quot;0&quot; ] ] } = Ch . query! ( pid , &quot;SHOW SETTINGS LIKE &#39;async_insert&#39;&quot; ) % Ch.Result { rows : [ [ &quot;async_insert&quot; , &quot;Bool&quot; , &quot;1&quot; ] ] } = Ch . query! ( pid , &quot;SHOW SETTINGS LIKE &#39;async_insert&#39;&quot; , [ ] , settings : settings )","ref":"readme.html#usage","title":"Ch - Usage","type":"extras"},{"doc":"NULL in RowBinary It's the same as in ch-go At insert time, Nil can be passed for both the normal and Nullable version of a column. For the former, the default value for the type will be persisted, e.g., an empty string for string. For the nullable version, a NULL value will be stored in ClickHouse. { :ok , pid } = Ch . start_link ( ) Ch . query! ( pid , &quot;&quot;&quot; CREATE TABLE ch_nulls ( a UInt8 NULL, b UInt8 DEFAULT 10, c UInt8 NOT NULL ) ENGINE Memory &quot;&quot;&quot; ) types = [ &quot;Nullable(UInt8)&quot; , &quot;UInt8&quot; , &quot;UInt8&quot; ] inserted_rows = [ [ nil , nil , nil ] ] selected_rows = [ [ nil , 0 , 0 ] ] % Ch.Result { num_rows : 2 } = Ch . query! ( pid , &quot;INSERT INTO ch_nulls(a, b, c) FORMAT RowBinary&quot; , inserted_rows , types : types ) % Ch.Result { rows : ^ selected_rows } = Ch . query! ( pid , &quot;SELECT * FROM ch_nulls&quot; ) Note that in this example DEFAULT 10 is ignored and 0 (the default value for UInt8 ) is persisted instead. UTF-8 in RowBinary When decoding String columns non UTF-8 characters are replaced with � (U+FFFD). This behaviour is similar to toValidUTF8 and JSON format. { :ok , pid } = Ch . start_link ( ) Ch . query! ( pid , &quot;CREATE TABLE ch_utf8(str String) ENGINE Memory&quot; ) bin = &quot; \\x 61 \\x F0 \\x 80 \\x 80 \\x 80b&quot; utf8 = &quot;a�b&quot; % Ch.Result { num_rows : 1 } = Ch . query! ( pid , &quot;INSERT INTO ch_utf8(str) FORMAT RowBinary&quot; , [ [ bin ] ] , types : [ &quot;String&quot; ] ) % Ch.Result { rows : [ [ ^ utf8 ] ] } = Ch . query! ( pid , &quot;SELECT * FROM ch_utf8&quot; ) % Ch.Result { rows : %{ &quot;data&quot; =&gt; [ [ ^ utf8 ] ] } } = pid |&gt; Ch . query! ( &quot;SELECT * FROM ch_utf8 FORMAT JSONCompact&quot; ) |&gt; Map . update! ( :rows , &amp; Jason . decode! / 1 ) To get raw binary from String columns use :binary type that skips UTF-8 checks. % Ch.Result { rows : [ [ ^ bin ] ] } = Ch . query! ( pid , &quot;SELECT * FROM ch_utf8&quot; , [ ] , types : [ :binary ] ) Timezones Decoding non-UTC datetimes like DateTime('Asia/Taipei') requires a timezone database. Encoding non-UTC datetimes like DateTime.new(~D[..], ~T[..], &quot;Asia/Taipei&quot;) raises an ArgumentError .","ref":"readme.html#caveats","title":"Ch - Caveats","type":"extras"},{"doc":"INSERT 1 million rows (original) $ MIX_ENV=bench mix run bench/insert.exs This benchmark is based on https://github.com/ClickHouse/clickhouse-go#benchmark Operating System: macOS CPU Information: Apple M1 Number of Available Cores: 8 Available memory: 8 GB Elixir 1.14.4 Erlang 25.3 Benchmark suite executing with the following configuration: warmup: 2 s time: 5 s memory time: 0 ns reduction time: 0 ns parallel: 1 inputs: 1_000_000 rows Estimated total run time: 28 s Benchmarking encode with input 1_000_000 rows ... Benchmarking encode stream with input 1_000_000 rows ... Benchmarking insert with input 1_000_000 rows ... Benchmarking insert stream with input 1_000_000 rows ... ##### With input 1_000_000 rows ##### Name ips average deviation median 99th % encode stream 1.63 612.96 ms ±11.30% 583.03 ms 773.01 ms insert stream 1.22 819.82 ms ±9.41% 798.94 ms 973.45 ms encode 1.09 915.75 ms ±44.13% 750.98 ms 1637.02 ms insert 0.73 1373.84 ms ±31.01% 1331.86 ms 1915.76 ms Comparison: encode stream 1.63 insert stream 1.22 - 1.34x slower +206.87 ms encode 1.09 - 1.49x slower +302.79 ms insert 0.73 - 2.24x slower +760.88 ms SELECT 500, 500 thousand, and 500 million rows (original) $ MIX_ENV=bench mix run bench/stream.exs This benchmark is based on https://github.com/ClickHouse/ch-bench Operating System: macOS CPU Information: Apple M1 Number of Available Cores: 8 Available memory: 8 GB Elixir 1.14.4 Erlang 25.3 Benchmark suite executing with the following configuration: warmup: 2 s time: 5 s memory time: 0 ns reduction time: 0 ns parallel: 1 inputs: 500 rows, 500_000 rows, 500_000_000 rows Estimated total run time: 1.05 min Benchmarking stream with decode with input 500 rows ... Benchmarking stream with decode with input 500_000 rows ... Benchmarking stream with decode with input 500_000_000 rows ... Benchmarking stream with manual decode with input 500 rows ... Benchmarking stream with manual decode with input 500_000 rows ... Benchmarking stream with manual decode with input 500_000_000 rows ... Benchmarking stream without decode with input 500 rows ... Benchmarking stream without decode with input 500_000 rows ... Benchmarking stream without decode with input 500_000_000 rows ... ##### With input 500 rows ##### Name ips average deviation median 99th % stream with decode 4.69 K 213.34 μs ±12.49% 211.38 μs 290.94 μs stream with manual decode 4.69 K 213.43 μs ±17.40% 210.96 μs 298.75 μs stream without decode 4.65 K 215.08 μs ±10.79% 213.79 μs 284.66 μs Comparison: stream with decode 4.69 K stream with manual decode 4.69 K - 1.00x slower +0.0838 μs stream without decode 4.65 K - 1.01x slower +1.74 μs ##### With input 500_000 rows ##### Name ips average deviation median 99th % stream without decode 234.58 4.26 ms ±13.99% 4.04 ms 5.95 ms stream with manual decode 64.26 15.56 ms ±8.36% 15.86 ms 17.97 ms stream with decode 41.03 24.37 ms ±6.27% 24.39 ms 26.60 ms Comparison: stream without decode 234.58 stream with manual decode 64.26 - 3.65x slower +11.30 ms stream with decode 41.03 - 5.72x slower +20.11 ms ##### With input 500_000_000 rows ##### Name ips average deviation median 99th % stream without decode 0.32 3.17 s ±0.20% 3.17 s 3.17 s stream with manual decode 0.0891 11.23 s ±0.00% 11.23 s 11.23 s stream with decode 0.0462 21.66 s ±0.00% 21.66 s 21.66 s Comparison: stream without decode 0.32 stream with manual decode 0.0891 - 3.55x slower +8.06 s stream with decode 0.0462 - 6.84x slower +18.50 s CI Results (click the latest workflow run and scroll down to &quot;Artifacts&quot;)","ref":"readme.html#benchmarks","title":"Ch - Benchmarks","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"support negative Enum values, fix Enum16 encoding","ref":"changelog.html#0-1-3-2023-04-23","title":"Changelog - 0.1.3 (2023-04-23)","type":"extras"},{"doc":"support Enum8 and Enum16 encoding","ref":"changelog.html#0-1-2-2023-04-23","title":"Changelog - 0.1.2 (2023-04-23)","type":"extras"},{"doc":"cleanup published docs","ref":"changelog.html#0-1-1-2023-04-23","title":"Changelog - 0.1.1 (2023-04-23)","type":"extras"}]